package ru.dbotthepony.kstarbound.defs.actor

import ru.dbotthepony.kstarbound.json.builder.JsonFactory

@JsonFactory
data class ActorMovementModifiers(
	val groundMovementModifier: Double = 1.0,
	val liquidMovementModifier: Double = 1.0,
	val speedModifier: Double = 1.0,
	val airJumpModifier: Double = 1.0,
	val liquidJumpModifier: Double = 1.0,
	val runningSuppressed: Boolean = false,
	val jumpingSuppressed: Boolean = false,
	val movementSuppressed: Boolean = false,
	val facingSuppressed: Boolean = false,
) {
	fun merge(other: ActorMovementModifiers): ActorMovementModifiers {
		return ActorMovementModifiers(
			groundMovementModifier = groundMovementModifier * other.groundMovementModifier,
			liquidMovementModifier = liquidMovementModifier * other.liquidMovementModifier,
			speedModifier = speedModifier * other.speedModifier,
			airJumpModifier = airJumpModifier * other.airJumpModifier,
			liquidJumpModifier = liquidJumpModifier * other.liquidJumpModifier,
			runningSuppressed = runningSuppressed || other.runningSuppressed,
			jumpingSuppressed = jumpingSuppressed || other.jumpingSuppressed,
			movementSuppressed = movementSuppressed || other.movementSuppressed,
			facingSuppressed = facingSuppressed || other.facingSuppressed,
		)
	}

	companion object {
		val EMPTY = ActorMovementModifiers()
	}
}
