package ru.dbotthepony.kstarbound.defs.actor.behavior

import com.google.common.collect.ImmutableMap
import ru.dbotthepony.kstarbound.json.builder.JsonFactory

/**
 * Reflects node on behavior graph.
 *
 * Behavior graph is not what most would expect, since this is code flow graph
 * (nodes represent Lua functions), and not decision tree.
 */
@JsonFactory
data class BehaviorNodeDefinition(
	/**
	 * actually should be called "parameters"
	 */
	val properties: ImmutableMap<String, NodeParameter> = ImmutableMap.of(),
	val output: ImmutableMap<String, NodeOutput> = ImmutableMap.of(),
)
